/**
  *  \file planetscentral/dbclient/dbint.h
  *  \brief Database Client: Integer Values
  */
#ifndef C2SERVER_PLANETSCENTRAL_DBCLIENT_DBINT_H
#define C2SERVER_PLANETSCENTRAL_DBCLIENT_DBINT_H

#include "planetscentral/dbclient/dbkey.h"

/** Integer value. */
class DbInt : public DbKey {
 public:
    DbInt(DbClient& client, string_t s);

    int32_t operator--();
    //DECR key                int, new value                          string[key] := string[key] - 1
    int32_t operator-=(int32_t val);
    //DECRBY key n            int, new value                          string[key] := string[key] - n
    int32_t get();
    //GET key                 string-or-nil                           string[key]
    int32_t replaceBy(int32_t newValue);
    //GETSET key value        string                                  tmp := string[key]; string[key] := value; tmp
    int32_t operator++();
    //INCR key                int, new value                          string[key] := string[key] + 1
    int32_t operator+=(int32_t val);
    //INCRBY key n            int, new value                          string[key] := string[key] + n
    void    set(int32_t newValue);
    //SET key value                                                   string[key] := value
    bool    setNew(int32_t newValue);
    //SETNX key value         int, 0 (already exists), 1 (created)    if (EXISTS key) SET key value
};

#endif
