/**
  *  \file planetscentral/mailout/template.h
  *  \brief Mailout: Template Processing
  */
#ifndef C2SERVER_PLANETSCENTRAL_MAILOUT_TEMPLATE_H
#define C2SERVER_PLANETSCENTRAL_MAILOUT_TEMPLATE_H

#include <map>
#include <list>
#include <memory>
#include "cpluslib/string.h"
#include "planetscentral/net/mimebuilder.h"

class TextFile;
class Url;

class Template {
 public:
    Template();

    void addVariable(string_t name, string_t value);
    void addFile(string_t url);

    std::auto_ptr<MimeBuilder> generate(TextFile& in, string_t forUser, string_t smtpAddress);

 private:
    void processLine(MimeBuilder& result, string_t text);
    void processCommand(string_t text);
    string_t expand(string_t text);
    
    std::map<string_t, string_t> variables;
    std::list<string_t> attachments;
};

#endif
